# triumfalno

Расшифровка АРГ(?) про Ростов и ВОЕННОЕ ВМЕШАТЕЛЬСТВО ЭРДОГАН ТРИУМФАЛЬНО.

## Расшифованные данные

Все карты и тексты - на странице [data.md](./data.md).

## Как пользоваться скриптом
```
./main.py --help
```

Опция `--decode` расшифровывает и выводит все строчки из `data.json`, которые принадлежат указанному `--type`.

Через `--decode-string "ВОЕННОЕ ВМЕШАТЕЛЬСТВО ТРИУМФАЛЬНО"` можно расшифровывать произвольные строки.

Через `--decode-file /path/to/file.txt` можно расшифровывать текст из файла.

Опция `--with-junk` пропускает удаление мусорных слов (бывает полезно, чтобы посмотреть как будет без удаления, на случай если удаляется что-то лишнее).

Через `--type` можно задать тип шифровок (`1` или `2`). 1 это обычные, составленные из слов, 2 появился позднее, он составлен из предложений. Значение по умолчанию - `1`.

## Пример

Например, если ты нашел такой текст: 

> Фехтовальные Навыки Отмечено! ТРИУМФАЛЬНО! Отмечено! РОБОТИЧЕСКИ Отмечено! Беркут Отмечено! ТРИУМФАЛЬНО! 80% ТРИУМФАЛЬНО! Отмечено! Чечевичная похлебка ЗАКОННО! Номер Индексирован Безукоризненно Отмечено! Сухогруз Откладывается Линейно ТРИУМФАЛЬНО! Ь - Его Величество

и хочешь его расшифровать, то делаешь либо так, экранируя восклицательные знаки и прочие символы, которые шеллу не понравятся:
```
./main.py --decode-string "Фехтовальные Навыки Отмечено\! ТРИУМФАЛЬНО\! Отмечено\! РОБОТИЧЕСКИ Отмечено\! Беркут Отмечено\! ТРИУМФАЛЬНО\! 80% ТРИУМФАЛЬНО\! Отмечено\! Чечевичная похлебка ЗАКОННО\! Номер Индексирован Безукоризненно Отмечено\! Сухогруз Откладывается Линейно ТРИУМФАЛЬНО\! Ь - Его Величество"
```
либо записываешь текст в файл, скажем `/tmp/text.txt`, и говоришь:
```
./main.py --decode-file /tmp/text.txt
```

В ответ получаешь:
```
ФОТОРОБОТ80%ТОЧНОСТЬ
```

## Другое

В файле `data.json` лежат тексты и метаинформация, собранные с архивов двача и со страниц соцсетей. Из этого файла генерируется страничка `data.md`.

Скрипт `search_2ch_archive.py` ищет треды в [архиве /b/](https://2ch.hk/b/arch/) или на a2ch.ru по известным ключевым словам.

Скрипт `analyze_new.py` - черновик частотного анализа положения букв для расшифровки шифртекстов 3-го типа, тексты которых лежат в папке `new` (см. [data.md](./data.md) о типах).

В `util.py` полезные функции для анализа с красочным выводом.

## Требования

Работает на Python 3. Рекомендуется установить модуль `termcolor` чтобы вывод был цветным (а util.py вообще не умеет без него работать).

Для `search_2ch_archive.py` нужен модуль `requests`.

Для корректной работы `gen_md.py` нужен установленный `imagemagick` в системе (используется утилита `convert` для создания превьюшек).

Предполагается использование на unix-like системах.
